=== modified file 'NEWS'
--- NEWS	2008-08-06 20:34:24 +0000
+++ NEWS	2008-08-07 00:28:43 +0000
@@ -16,6 +16,9 @@
     * sftp transport: added missing ``FileExists`` case to
       ``_translate_io_exception`` (Christophe Troestler, #123475)
 
+    * ``bzr upgrade`` on remote branches accessed via bzr:// and
+      bzr+ssh:// now works.  (Andrew Bennetts)
+
   API CHANGES:
 
   INTERNALS:

=== modified file 'bzrlib/transport/remote.py'
--- bzrlib/transport/remote.py	2008-06-18 01:03:51 +0000
+++ bzrlib/transport/remote.py	2008-07-25 03:12:11 +0000
@@ -421,9 +421,6 @@
     def disconnect(self):
         self.get_smart_medium().disconnect()
 
-    def delete_tree(self, relpath):
-        raise errors.TransportNotPossible('readonly transport')
-
     def stat(self, relpath):
         resp = self._call2('stat', self._remote_path(relpath))
         if resp[0] == 'stat':

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2008-08-04 06:47:59 +0000
+++ bzrlib/upgrade.py	2008-08-07 00:25:38 +0000
@@ -21,6 +21,7 @@
 
 from bzrlib.bzrdir import ConvertBzrDir4To5, ConvertBzrDir5To6, BzrDir, BzrDirFormat4, BzrDirFormat5, BzrDirFormat
 import bzrlib.errors as errors
+from bzrlib.remote import RemoteBzrDir
 from bzrlib.transport import get_transport
 import bzrlib.ui as ui
 
@@ -30,6 +31,9 @@
     def __init__(self, url, format):
         self.format = format
         self.bzrdir = BzrDir.open_unsupported(url)
+        if isinstance(self.bzrdir, RemoteBzrDir):
+            self.bzrdir._ensure_real()
+            self.bzrdir = self.bzrdir._real_bzrdir
         if self.bzrdir.root_transport.is_readonly():
             raise errors.UpgradeReadonly
         self.transport = self.bzrdir.root_transport

